/*---------------------------------------------------------------------------*
 *
 * Project
 *        fXPlayMidi
 * $RCSfile: mnplayers.c,v $
 * $Date: 1998/04/18 16:02:19 $
 * $Author: klmcw $
 * $Revision: 1.1 $
 *
 *---------------------------------------------------------------------------*
 * $Log: mnplayers.c,v $
 * Revision 1.1  1998/04/18 16:02:19  klmcw
 * Initial revision
 *
 *---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------*/
#include "fXPlayMidi.h"
#include "mnplayers.h"

typedef struct {
  char *Label;
  char *Shortcut;
  int (*cb)(FL_OBJECT *);
} mnDef_t;

/*---------------------------------------------------------------------------*/

static int mniHorz_cb(FL_OBJECT *);
static int mniVert_cb(FL_OBJECT *);

/*---------------------------------------------------------------------------*/

static mnDef_t mnDef[] = {
  { "Start of Menu", NULL, NULL       },
  { "Horizontal"   , "#H", mniHorz_cb},
  { "Vertical"     , "#V", mniVert_cb },
};

#define mnDefSz (sizeof(mnDef) / sizeof(mnDef_t))

/*---------------------------------------------------------------------------*/
int
mnplayersCreate(XPMApp_t *App)
{
  register int i;
  FL_OBJECT *mnPlayers = App->Album->mnPlayers;

  /* Menu item numbers are 1 based */
  for(i = 1; i < mnDefSz; i++) {
    fl_addto_menu(mnPlayers, mnDef[i].Label);
    if(mnDef[i].Shortcut)
      fl_set_menu_item_shortcut(mnPlayers, i, mnDef[i].Shortcut);
  }

  return(0);
}
/*---------------------------------------------------------------------------*/
int
mnplayersProcMenuItem(FL_OBJECT *obj)
{
  char chMI[10];
  int mni = fl_get_menu(obj);

  if((0 >= mni) || (mni >= mnpLast)) {
    sprintf(chMI, "%d", fl_get_menu(obj));
    fl_show_alert("Invalid Item for Players Menu", chMI, "Internal Error!", 1);
  } else if(mnDef[mni].cb)
    if((*mnDef[mni].cb)(obj) < 0)
      return(-1);

  return(0);
}
/*---------------------------------------------------------------------------*/
static int
mniHorz_cb(FL_OBJECT *ob)
{
  static int firstTime = 1;
  XPMApp_t *App = (XPMApp_t *)ob->form->u_vdata;

  fXPlayMidiRedisplayForm(App->HPlayer->fmHPlayer, firstTime);

  firstTime = 0;

  return(0);
}
/*---------------------------------------------------------------------------*/
static int
mniVert_cb(FL_OBJECT *ob)
{
  static int firstTime = 1;
  XPMApp_t *App = (XPMApp_t *)ob->form->u_vdata;

  fXPlayMidiRedisplayForm(App->VPlayer->fmVPlayer, firstTime);

  firstTime = 0;

  return(0);
}
/*---------------------------------------------------------------------------*/
